From 47834ec5b20982c0d9980f044af160238c7ebabe Mon Sep 17 00:00:00 2001
From: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date: Tue, 30 Oct 2018 10:41:37 +0100
Subject: [PATCH] mDNS: responder upgraded with delay functionality + cleanup

Squashed commit of the following:

commit 833acba123af7aad92a4b70fc01403c69885bc89
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Thu Oct 25 09:41:00 2018 +0200

    mDNS: add new files to filelists + solve compile errors

    ttl setting removed from example code.
    string.h included where needed.

commit d45bcaf61346efd0d5da79a5dc9002136083f0b7
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 24 16:15:11 2018 +0200

    mDNS: author comment update + things left to implement update

commit e533d525da610f836f6a363174a130dc97386065
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 24 16:02:08 2018 +0200

    mDNS: add #if LWIP_IPVx to new code

    LWIP_IPV4/6 can be enabled or disabled, all combination should work.

commit 3240334d302f824d1d277c3509f711be49823fbb
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 24 15:13:15 2018 +0200

    mDNS: solve commenting and style issues

commit 6e04523a50f49900d94fb54745802a009e37e2ab
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 24 14:38:50 2018 +0200

    mDNS: timeouts -> create function for mdns timeout handling

    mdns_set_timeout will check if the timer is running or not and will
    update the flag to running after starting the timer.
    Multicast timeouts were not set everywhere they needed to be. This
    is solved.
    mulit <-> multi typo fixed.

commit 74b380a38328457ff6fe1e08898abc45ca811955
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Tue Oct 23 10:45:01 2018 +0200

    mDNS: send multicast response on QU questions if not multicasted recently.

    If a QU question is received, the responder should multicast the
    answer if it did not multicast that record within 25% of it's ttl.

    we implemented a stripped down version, meaning that we look at the
    records as one set and use one timer for all records. So if the
    responder multicasted a record within 30s of the QU question it
    will respond with a unicast answer. if not, it will respond
    multicast.

commit fb29425ade94407ffe639657467a13fea97a3585
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Mon Oct 22 16:44:40 2018 +0200

    MDNS: change timeouts from max time to random time

commit ea3febfc77069b48f2d8653a8716c56047cc6391
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Mon Oct 22 16:40:27 2018 +0200

    MDNS: changed printfs to lwip debug messages

commit 76275584306af516da1a070a03f93065c7f4be27
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Mon Oct 22 16:26:16 2018 +0200

    mDNS: improved split for unicast vs multicast and direct vs delayed

    unicast delayed message are now possible and multicast direct msgs to.

commit 945c6fe17a010b0be0747cf2cf5ea146d7a2e92b
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Fri Oct 19 16:09:07 2018 +0200

    mDNS: ignore responses with src port != 5353 (rfc6762 section 6)

commit d2baf4c5dc47bd1fdd8fe3d707fd8d34f8714f86
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Fri Oct 19 13:58:49 2018 +0200

    mDNS: source address check added

    RFC6762 section 5.5 and 11 define that we should check that all
    packets originated on the local link.

commit 8f2dfdf44e3df30a0ff0045f6cc7ae025fd51dad
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 17 14:03:40 2018 +0200

    mDNS: do not multicast a rr within one second.

    RFC6762 section 6: prevent network flooding. When a multicast packet
    is send out, we start a timeout of 1s within this 1 second all
    multicast requests are ignored. We do not make a difference between
    the records, we set the delay for all records.

commit eb57affd9ba15243bd5f735f67ea7b154821da0a
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 17 13:47:02 2018 +0200

    mDNS: addr bug, we should not clear full outmsg

    memset deleted also the dest_addr and dest_port, which should remain
    and is constant. This commit contains a function that resets only the
    needed parts of the outmsg struct.

commit 02b4d8393785922cd62778e80cd6e05430c3b776
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 17 09:54:40 2018 +0200

    mDNS split delayed multicast msgs into ipv4 and ipv6 buffers.

    We are implementing a two resolvers in one (IPv6 and IPv4 together).
    For directly send answers, this does not matter. But for delayed
    answers, we need to make a separate buffer for both.

commit 01399ca63ec08053c3fd3a0a84f9500c14138a17
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Tue Oct 16 16:10:16 2018 +0200

    mDNS: add probe query detection.

    If a probe query is detected a direct unicast respond is send.
    Independent of the QU/QM bit.

commit d1686d1d823bf31690c4054cb53ac3bca3a2b9e1
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Mon Oct 15 16:16:05 2018 +0200

    mDNS improved delay vs direct send behavior on questions

    All multicast answers are delayed at the moment. While all unicast
    answers are send out directly. A unicast answer is send when this
    is requested by the QU bit, when a unicast question was send or
    when the question originated from a legacy querier.

commit 969c6aece4f3423a7f6c0e204f0360ecf3c40d33
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Fri Oct 12 15:35:02 2018 +0200

    mDNS: support for direct and delayed sends

    There are two ways to send a response, directly and after a delay.
    A probe or an announce msg are now send via the direct way and
    all responses are send via the delayed way.

commit 69b37f30407d76fa1354e0442c1fb9cd5c6c1002
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Fri Oct 12 10:01:04 2018 +0200

    mDNS: remove netif from mDNS structs

    it's more practical to use netif as a wrapper instead of wrapping
    netif in the mdns packets. netif contains all information.
    Netif is passed along were needed.

commit bf500b27e1934bb91692d193d49310c3a918863f
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Thu Oct 11 15:16:21 2018 +0200

    mDNS fix TTL bug

    MDNS_TTL changed to MDNS_IP_TTL for clarity.
    The mDNS RR ttl does not need to be settalbe, this is against the
    RFC. RFC6762 states that for rr's with the hostname in them
    somewhere, the ttl should be 120s. If it's not in their it should
    be 75 minutes and if the answer is send to a legacy dns querier,
    it should be no more then 10s.
    This patch corrects the ttl behavior to the RFC.

commit 939e7fda84fe7767f20b950b9cfd665ef410d6a8
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Thu Oct 11 10:43:34 2018 +0200

    mDNS split off output related functionality and put in other file

    A lot of functions are only needed for the generation of the pbuf,
    by separating them into another file we clean up the mdns file.
    We only need the mdns_send_outpacket function as interface.
    Packet definition is now completely separated from packet
    generation.

commit a95c659e94eeb0507d8bdf60bf245188ad346983
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 10 14:37:22 2018 +0200

    mDNS take out domain related functionality and put in other file.

    The mDNS file is getting very big and a lot still needs to be added.
    For clarity reasons it's better to split these domain functions
    from the main mDNS file.

commit 3dbb0e15eea9c137b42b14cc567ca31bd74548e1
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 10 09:59:02 2018 +0200

    mDNS: authority section of probe message needs to contain all records

    see RFC 6762 section 8.2: for tiebreaking to work correctly in all
    cases, the Authority section must contain all the records and
    proposed rdata being probed for uniqueness.

commit bfe8159332fb00d6381e4f145a729bc897dd1e0a
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 10 09:57:45 2018 +0200

    mDNS: move legacy question generation to mdns_send_outpacket

    It's better to do the pbuf generation in one place.
    Especially important for message delaying etc.

commit 0e1f49c0f1b373d0632c53833f8eac6e3bbc34be
Author: Jasper Verschueren <jasper.verschueren@apart-audio.com>
Date:   Wed Oct 10 09:40:03 2018 +0200

    mDNS move probe question packet generation to mdns_send_outpacket

    The probe any questions were added to the pbuf in the send_probe
    routine. It is better if we move all pbuf generation to the output
    function so later on packets can be delayed etc. keep it all in
    one place.
---
 contrib/examples/mdns/mdns_example.c |    4 +-
 src/Filelists.cmake                  |    2 +
 src/Filelists.mk                     |    4 +-
 src/apps/mdns/mdns.c                 | 1798 ++++++++------------------
 src/apps/mdns/mdns_domain.c          |  548 ++++++++
 src/apps/mdns/mdns_out.c             |  992 ++++++++++++++
 src/include/lwip/apps/mdns.h         |    8 +-
 src/include/lwip/apps/mdns_domain.h  |   75 ++
 src/include/lwip/apps/mdns_opts.h    |    1 +
 src/include/lwip/apps/mdns_out.h     |  121 ++
 src/include/lwip/apps/mdns_priv.h    |  127 +-
 test/unit/mdns/test_mdns.c           |    1 +
 12 files changed, 2436 insertions(+), 1245 deletions(-)
 create mode 100644 src/apps/mdns/mdns_domain.c
 create mode 100644 src/apps/mdns/mdns_out.c
 create mode 100644 src/include/lwip/apps/mdns_domain.h
 create mode 100644 src/include/lwip/apps/mdns_out.h

diff --git a/contrib/examples/mdns/mdns_example.c b/contrib/examples/mdns/mdns_example.c
index f5cc0585a..208048a2d 100644
--- a/contrib/examples/mdns/mdns_example.c
+++ b/contrib/examples/mdns/mdns_example.c
@@ -56,8 +56,8 @@ mdns_example_init(void)
 #if LWIP_MDNS_RESPONDER
   mdns_resp_register_name_result_cb(mdns_example_report);
   mdns_resp_init();
-  mdns_resp_add_netif(netif_default, "lwip", 3600);
-  mdns_resp_add_service(netif_default, "myweb", "_http", DNSSD_PROTO_TCP, 80, 3600, srv_txt, NULL);
+  mdns_resp_add_netif(netif_default, "lwip");
+  mdns_resp_add_service(netif_default, "myweb", "_http", DNSSD_PROTO_TCP, 80, srv_txt, NULL);
   mdns_resp_announce(netif_default);
 #endif
 }
diff --git a/src/Filelists.cmake b/src/Filelists.cmake
index 21830332f..6003c6fc0 100644
--- a/src/Filelists.cmake
+++ b/src/Filelists.cmake
@@ -199,6 +199,8 @@ set(lwipsntp_SRCS
 # MDNS responder
 set(lwipmdns_SRCS
     ${LWIP_DIR}/src/apps/mdns/mdns.c
+    ${LWIP_DIR}/src/apps/mdns/mdns_out.c
+    ${LWIP_DIR}/src/apps/mdns/mdns_domain.c
 )
 
 # NetBIOS name server
diff --git a/src/Filelists.mk b/src/Filelists.mk
index 65ebda9ee..7e076f347 100644
--- a/src/Filelists.mk
+++ b/src/Filelists.mk
@@ -177,7 +177,9 @@ SMTPFILES=$(LWIPDIR)/apps/smtp/smtp.c
 SNTPFILES=$(LWIPDIR)/apps/sntp/sntp.c
 
 # MDNSFILES: MDNS responder
-MDNSFILES=$(LWIPDIR)/apps/mdns/mdns.c
+MDNSFILES=$(LWIPDIR)/apps/mdns/mdns.c \
+	$(LWIPDIR)/apps/mdns/mdns_out.c \
+	$(LWIPDIR)/apps/mdns/mdns_domain.c
 
 # NETBIOSNSFILES: NetBIOS name server
 NETBIOSNSFILES=$(LWIPDIR)/apps/netbiosns/netbiosns.c
